( This first part of a game level comes from the template file  )
( named  \gcs\guards\guardsrc.4th.  The game editor copies this )
( from the template file and then appends specific settings for )
( the guards for this level.  The combination is a file named   )
( guard0.4th or guard1.4th or guard2.4th, etc. depending upon   )
( the game level.  For use under 32-bit Windows.                )

CAPS ON  ( just to be sure case will be ignored  )

VARIABLE GUARD#  ( used during loading to help initialize the )
                 (  USER variables in the correct task        )


( Return the task related to a particular guard number.  This )
(  is used to allow easy access to a particular task's local  )
(  variables.                                                 )
: TASK@  ( - task)  GUARD# @ CELLS TASKS + @  ;


0 constant ENEMTYPE ( 0=normal 1=erratic flying 2=smooth flying )
0 constant ENEMRANGE ( 0=max attack range, 7=only when touching player )

: waitthenhunt
   begin
    10 sentryorhunt
   0 until ;

: randompatrol
  begin
     2 randomwalk 
     intflag bit@ if 
      -1 huntflag bit! trackdown  
     then 
  0 until ;

: staystanding
   begin
    10 standandshoot
   0 until
;

' waitthenhunt constant 'nopatrol
' randompatrol constant 'randompatrol
' staystanding constant 'staystanding

( 0 constant rbqk       ( quickness of a robot )
( 1 constant rbt1 ( temporary storage spot )
( 2 constant rbsp ( speed of a robot )
( 6 constant rbht ( mx hit pts *256 + current hit points )
( 7 constant rbgn ( gun strength* 256 + gun skill )
( 8 constant rbql ( unused * 256 + quality of guard in general )
( 9 constant rbal  ( current alertness of guard * 256 with fractional part )

( [orders#] -- []  Sets a guards orders to 0=sentry then hunt )
(                                          1=random patrol then hunt )
(                                          2=stand and shoot w/o walking )
: getorders ( # -)
     ?dup if
            1 =  if ( ie for 1          ) 'randompatrol
               else ( ie not 0 and not 1) 'staystanding
               then
        else        ( ie for 0          ) 'nopatrol
     then ( rstrt robo[]! )
     ( xt) GUARD# @ CELLS INITS +  !  ( assign executable to task)
  ;

( [quickness value] -- []  set this guard's quickness to value 1 thru 6 )
: setspeed ( # -)  1 max 6 min 256 *  TASK@ RBQK LOCAL !  ;

( [hitpts] -- []      Set this guard's hitpts to value 1 through 63 )
: sethitpts ( # -)  1 max 63 min 256 *  TASK@ RBHT LOCAL !  ;

( [gun skill]  [gun strength] -- []  Set guard's gun power and accuracy )
(                                   !!!!!!!!! note this word takes *2* values! )
: setgun ( skill strength -)
  1 max 31 min 256 * +   TASK@ RBGN LOCAL !  ;

( [alertness value] -- []    Set this guard's initial alertness value 10-127 )
: setalert ( # -)
  10 max 127 min 256 * ( n)  TASK@ RBAL LOCAL !  ;

( [quality] -- []  Set the guard's quality to value from 0 thru 3 )
(                  !!!!!! strange:  0=dumb  1=avg  2=great 3=vegetable )

: SETQUAL  ( # -)
  TASK@ PUSH ( #)
  0 MAX 3 MIN  R@ RBQL LOCAL @ $FF00 AND OR  POP RBQL LOCAL !  ;

( [rangecode] -- []  Set the guard's attack range to value from 0 thru 7 )
( 0=max range,  7 = only when touching player )
: SETRANGE ( # -)
  TASK@ PUSH ( #)
  0 MAX 7 MIN 8 <<<   R@ RBQL LOCAL @  $FF AND OR
  POP RBQL LOCAL !  ;

: setdefaults  ( -)  TASK@ ( task) PUSH
   ( fcs -- Under the new approach, the word that the task  )
   (  will execute is stored in the array of CELLS named    )
   (  INITS )

   ( 'nopatrol rstrt robo[]! )
   'nopatrol  GUARD# @ CELLS INITS +  !  ( assign executable to task)
        ENEMTYPE  R@ RBTYP LOCAL ! ( 256* zoffset + guard type number)
       ENEMRANGE  setrange
         3 256 *  R@ RBQK  LOCAL ! ( quickness)
               0  R@ RBT1  LOCAL !
             230  R@ RBSP  LOCAL ! ( speed)
         4 256 *  R@ RBHT  LOCAL !
   64 256 * 16 +  R@ RBGN  LOCAL !
               0  setqual
    50 256 * 0 +  R@ RBAL  LOCAL !
   POP ( task) DROP
 ;

( Make this guard# the current guard for setting params )
(  and set defaults                                     )
: SETGUARD#  ( guard# -)  GUARD# ! (  )  SETDEFAULTS  ;


( last line of the template file guardsrc.4th )

